/* -*-c++-*- */
#ifndef ACTIVE_DEPS_H
#define ACTIVE_DEPS_H

#include "Corpus.h"
#include "Macros.h"

#include <assert.h>

#include <vector>

using std::vector;

class active_deps {
public:
  active_deps(const char* const fname,
              const double trbeam,
              const int L,
              corpus& restrict data,
              const bool truth_marg,
              const bool reattach_comma);
  ~active_deps();

  int active_N(const int id) const;
  const int*  active_num(const int id) const;
  const int** active_heads(const int id) const;
  const int** active_labels(const int id) const;

private:
  vector<const int**> _activeH;
  vector<const int**> _activeL;
  vector<const int*> _activeN;
  vector<int> _sizes;
};


/*** inlined implementation ***/
inline int active_deps::active_N(const int id) const {
  assert(id >= 0); assert(id < (int)_sizes.size());
  return _sizes[id];
}
inline const int* active_deps::active_num(const int id) const {
  assert(id >= 0); assert(id < (int)_sizes.size());
  return _activeN[id];
}
inline const int** active_deps::active_heads(const int id) const {
  assert(id >= 0); assert(id < (int)_sizes.size());
  return _activeH[id];
}
inline const int** active_deps::active_labels(const int id) const {
  assert(id >= 0); assert(id < (int)_sizes.size());
  return _activeL[id];
}

#endif /* ACTIVE_DEPS_H */
