/* -*-c++-*- */
#ifndef AUXCORPUS_H
#define AUXCORPUS_H
/* AuxCorpus : A corpus of auxiliary dependencies matching some
   dataset. */

#include "Macros.h"
#include "AuxDeps.h"

#include <assert.h>

#include <vector>

using std::vector;

class auxcorpus {
public:
  auxcorpus();

  void load(const char* const fname, const int L);

  int Naux() const;
  int N() const;
  const auxdeps& get(const int idx) const;

private:
  int _Naux;
  vector<auxdeps> _aux;
};



/*** inlined implementation ***/

inline auxcorpus::auxcorpus() {}

inline int auxcorpus::Naux() const { return _Naux; }
inline int auxcorpus::N() const    { return (int)_aux.size(); }

inline const auxdeps& auxcorpus::get(const int idx) const {
  CHECK(assert(idx >= 0); assert(idx < (int)_aux.size()));
  return _aux[idx];
}

#endif /* AUXCORPUS_H */
