#include "AuxDeps.h"

void auxdeps::add(const vector<int>& restrict heads,
                  const vector<int>& restrict labels) {
  vector<idx_t> hh;
  vector<lab_t> ll;
  assert(heads.size() == labels.size());
  for(unsigned i = 0; i < heads.size(); ++i) {
    hh.push_back(ICONV_NULL(heads[i]));
    ll.push_back(LCONV(labels[i]));
  }
  _aux_h.push_back(hh);
  _aux_l.push_back(ll);
  CHECK(assert(_aux_h.size() == _aux_l.size()));
}


vector<bool> auxdeps::agree(const idx_t h, const idx_t m,
                            const lab_t l_hm) const {
  CHECK(assert(_aux_h.size() == _aux_l.size()));
  /* create a list of whether each auxiliary source agrees or
     disagrees with the current dependency */
  vector<bool> agr;
  for(unsigned i = 0; i < _aux_h.size(); ++i) {
    agr.push_back((_aux_h[i][m] == h) &&
                  (_aux_l[i][m] == l_hm));
  }
  return agr;
}
