/* -*-c++-*- */
#ifndef AUXDEPS_H
#define AUXDEPS_H
/* AuxDeps : A container for dependencies from other parsers. */

#include "Macros.h"

#include <assert.h>

#include <vector>

using std::vector;

class auxdeps {
public:
  auxdeps();

  void add(const vector<int>& restrict heads,
           const vector<int>& restrict labels);

  vector<bool> agree(const idx_t h, const idx_t m,
                     const lab_t l_hm) const;

  int Naux() const;

private:
  vector<vector<lab_t> > _aux_h;
  vector<vector<idx_t> > _aux_l;
};



/*** inlined implementation ***/

inline auxdeps::auxdeps() {}

inline int auxdeps::Naux() const { return (int)_aux_h.size(); }

#endif /* AUXDEPS_H */
