/* -*-c++-*- */
#ifndef MACROS_H
#define MACROS_H

#include "Bits.h"

/* current version of package */
#define VERSION "0.1.0"

/* maximum values for #labels, #words, and #active; reasonable for
   most applications */
#define O3PARSER_MAX_LABELS   LMAX
#define O3PARSER_MAX_SENTLEN  IMAX
#define O3PARSER_MAX_ACTIVE   LMAX

/* tolerance for floating-point error */
#define O3PARSER_TOL 1e-8

/* perform or ignore a check; "CAUTIOUS" should be defined by the
   compiler invocation (e.g., "-DCAUTIOUS") */
#ifdef CAUTIOUS
#define CHECK(code) code
#else /* CAUTIOUS */
#define CHECK(code)
#endif /* CAUTIOUS */

/* fun with g++ extensions...; this works for pointers and
   references and also the this pointer */
#define restrict __restrict__

#endif /* MACROS_H */
