#include "O3Ablation.h"

#include <iostream>

using std::cerr;
using std::endl;

/* string names for different ablation types */
const string o3ablation::names[] = {
  "none", "gsib", "sibs", "all4", "allg", "alls", "xc07", "mp06", "posi"
};


int o3ablation::code(const string& str) {
  for(int i = 0; i < NUM_TYPES; ++i) {
    if(str == names[i]) { return i; }
  }
  cerr << "O3Ablation : unknown ablation type: " + str << endl;
  assert(0);
}


string o3ablation::name(const int ablation) {
  assert(ablation >= 0);
  assert(ablation < NUM_TYPES);
  return names[ablation];
}
