/* -*-c++-*- */
#ifndef O3AUXPERC_H
#define O3AUXPERC_H
/* O3AuxPerc : Averaged perceptron training for a parser combination
   model. */

#include "O3Parser.h"
#include "O3Features.h"
#include "O3Trainer.h"
#include "Bits.h"
#include "AuxCorpus.h"

/* forward declaration */
class o1parser;

class o3auxperc : public o3trainer {
public:
  o3auxperc();
  virtual ~o3auxperc();

protected:
  /* initialize the specialized trainer with options */
  virtual void usage_impl() const;
  virtual void init_impl(const o3trainer::strmap& opts);

  /* training interface */
  virtual void train_start();
  virtual void iter_start();
  virtual void iter_end(string& logline, string& repline);
  virtual void process(const ex* const restrict e);
  virtual void classify(const ex* const restrict e,
                        vector<int>& restrict ret_h,
                        vector<int>& restrict ret_l) const;

private:
  class o1collect;

  uint64_t _mistakes; /* number of mistakes made by the perceptron */
  auxcorpus _traux;
  auxcorpus _valaux;
  o1parser* _FOP;
};

#endif /* O3AUXPERC_H */
