/* -*-c++-*- */
#ifndef O3BRUTEFORCE_H
#define O3BRUTEFORCE_H
/* O3BruteForce : A trivial parser that uses brute-force enumeration
   to perform inference.  Mostly useful for testing the inference of
   the othe parsers. */

#include "Macros.h"
#include "O3Part.h"
#include "O3Parser.h"

class o3bruteforce : public o3parser {
public:
  o3bruteforce(const int inL,
               const bool inmultiroot,
               const bool inpruned,
               const bool insibparser);
  ~o3bruteforce();

  /* infererence implementation */
  template<class PartScorer>
  double argmax(const int N, const PartScorer& restrict S,
                vector<int>& restrict ret_heads,
                vector<int>& restrict ret_labels);
  template<class PartScorer>
  double kargmax_next(const PartScorer& restrict S,
                      double& restrict ret_score,
                      vector<int>& restrict ret_heads,
                      vector<int>& restrict ret_labels);
  template<class PartScorer>
  double partition(const int N, const PartScorer& restrict S);
  template<class PartScorer>
  double marginals(const int N, const PartScorer& restrict S,
                   o3part::dmap& restrict M);

private:
  /* enumerate all valid trees and apply some functor to them */
  template<class PartScorer, class TreeFunc>
  void foralltrees(const PartScorer& restrict S,
                   TreeFunc& restrict f) const;
};

#ifndef EXPLICIT_TEMPLATES
#include "O3BruteForce.tcc"
#endif /* EXPLICIT_TEMPLATES */

#endif /* O3BRUTEFORCE_H */
