/* -*-c++-*- */
#ifndef O3DECODER_H
#define O3DECODER_H
/* O3Decoder : Trainer that parses using an existing model. */

#include "O3Parser.h"
#include "O3Features.h"
#include "O3Trainer.h"
#include "Bits.h"

#include <stdio.h>

#include <string>
#include <vector>

using std::string;
using std::vector;

class o1parser; /* forward declaration */

class o3decoder : public o3trainer {
public:
  o3decoder();
  virtual ~o3decoder();

protected:
  /* initialize the specialized trainer with options */
  virtual void usage_impl() const;
  virtual void init_impl(const o3trainer::strmap& opts);

  /* training interface */
  virtual void train_start();
  virtual void iter_start();
  virtual void iter_end(string& logline, string& repline);
  virtual void process(const ex* const restrict e);
  virtual void classify(const ex* const restrict e,
                        vector<int>& restrict ret_h,
                        vector<int>& restrict ret_l) const;

private:
  string _outfstem;       /* output file-stem */
  string _pdir;           /* parameter directory */
  FILE*  _outf;           /* output file */
  uint64_t _nwords;       /* number of words in the current training run */
  uint64_t _ncorrect;     /* number of correct heads */
  vector<int> _range;     /* range of iterations to consider */
  int _range_pos;         /* position in the current range */
  int _ensemble;          /* size of parameter ensemble if applicable */
  int _timed;             /* number of times to decode each example */
};

#endif /* O3DECODER_H */
