#include "O3Features.h"

#include <stdio.h>
#include <string.h>


/* o3features methods */
o3features::o3features(const int inL, const bool avg)
  : _L(inL),
    _Wavg(avg ? new o3params_avg(_L) : NULL),
    _Wlin(avg ? NULL : new o3params_lin(_L)),
    _FGavg_dot(NULL),
    _FGavg_adot(NULL),
    _FGavg_add(NULL),
    _FGlin_dot(NULL),
    _FGlin_ldot(NULL),
    _FGlin_add(NULL) {
  assert(_Wavg != NULL || _Wlin != NULL);
  assert(_Wavg == NULL || _Wlin == NULL);
}

o3features::~o3features() {
  if(_Wavg       != NULL) { delete _Wavg; }
  if(_Wlin       != NULL) { delete _Wlin; }
  if(_FGavg_dot  != NULL) { delete _FGavg_dot; }
  if(_FGavg_adot != NULL) { delete _FGavg_adot; }
  if(_FGavg_add  != NULL) { delete _FGavg_add; }
  if(_FGlin_dot  != NULL) { delete _FGlin_dot; }
  if(_FGlin_ldot != NULL) { delete _FGlin_ldot; }
  if(_FGlin_add  != NULL) { delete _FGlin_add; }
}
