/* -*-c++-*- */
#ifndef O3GBFINSIDE_H
#define O3GBFINSIDE_H
/* O3GBFInside : Inside pass for third-order grandparent parsing. */

#include "Macros.h"

template<class State>
class o3gbfinside {
public:
  static double inside(const State& restrict X, const bool multiroot);

private:
  typedef typename State::accum accum;

  /* helper for singleroot constructions */
  static void sroot(const State& restrict X);
  /* bottom-up constructions; labeled structures */
  static void lbox(const State& restrict X,
                   const int i_s, const int i_m);
  static void ltrap(const State& restrict X,
                    const int i_h, const int i_m);
  static void lwedge(const State& restrict X,
                     const int i_h, const int i_e);
  /* bottom-up constructions */
  static void ubox(const State& restrict X,
                   const int i_s, const int i_m);
  static void utrap(const State& restrict X,
                    const int i_h, const int i_m);
  static void uwedge(const State& restrict X,
                     const int i_h, const int i_e);
};

#ifndef EXPLICIT_TEMPLATES
#include "O3GBFInside.tcc"
#endif /* EXPLICIT_TEMPLATES */

#endif /* O3GBFINSIDE_H */
