/* -*-c++-*- */
#ifndef O3MMSSGD_H
#define O3MMSSGD_H
/* O3MMSSGD : Max-margin stochastic sub-gradient training. */

#include "O3Parser.h"
#include "O3Features.h"
#include "O3Trainer.h"
#include "Bits.h"


class o3mmssgd : public o3trainer {
public:
  o3mmssgd();
  virtual ~o3mmssgd();

protected:
  /* initialize the specialized trainer with options */
  virtual void usage_impl() const;
  virtual void init_impl(const o3trainer::strmap& opts);

  /* training interface */
  virtual void train_start();
  virtual void iter_start();
  virtual void iter_end(string& logline, string& repline);
  virtual void process(const ex* const restrict e);
  virtual void classify(const ex* const restrict e,
                        vector<int>& restrict ret_h,
                        vector<int>& restrict ret_l) const;

private:
  uint64_t _mistakes;      /* number of mistakes */
  uint64_t _num_processed; /* number of examples processed total */
  double _C;               /* regularization constant */
};

#endif /* O3MMSSGD_H */
