#include "O3Oracle.h"

#include <stdlib.h>

o3oracle::o3oracle(const vector<int>& heads,
                   const vector<int>& labels)
  : _heads(copyheads(heads)), _labels(copylabels(labels)) {
  /* consistency checks */
  assert(heads.size() == labels.size());
}

o3oracle::~o3oracle() { free((idx_t*)_heads); free((lab_t*)_labels); }

const idx_t* o3oracle::copyheads(const vector<int>& v) {
  const int n = (int)v.size();
  if(n == 0) { return NULL; }
  idx_t* const arr = (idx_t*)malloc(n*sizeof(idx_t));
  assert(arr != NULL);
  for(int i = 0; i < n; ++i) { arr[i] = ICONV_NULL(v[i]); }
  return arr;
}

const lab_t* o3oracle::copylabels(const vector<int>& v) {
  const int n = (int)v.size();
  if(n == 0) { return NULL; }
  lab_t* const arr = (lab_t*)malloc(n*sizeof(lab_t));
  assert(arr != NULL);
  for(int i = 0; i < n; ++i) { arr[i] = LCONV(v[i]); }
  return arr;
}
