template<class PartScorer>
double o3part::score_with(PartScorer& restrict S) const {
  /* dispatch according to type */
  switch(type()) {
  case O3PART_DEP1: return S.dep1(i2(), i3(), l2());
  case O3PART_DEP2: return S.dep2(i2(), i3(), l2());
  case O3PART_DEP3: return S.dep3(i2(), i3(), l2());

  case O3PART_SIB1: return S.sib1(i2(), i3(), i4(), l2(), l3());
  case O3PART_SIB2: return S.sib2(i2(), i3(), i4(), l2(), l3());

  case O3PART_GCI1: return S.gci1(i1(), i2(), i3(), l1(), l2());
  case O3PART_GCI2: return S.gci2(i1(), i2(), i3(), l1(), l2());
  case O3PART_GCO1: return S.gco1(i1(), i2(), i3(), l1(), l2());
  case O3PART_GCO2: return S.gco2(i1(), i2(), i3(), l1(), l2());

  case O3PART_GCIS: return S.gcis(i1(), i2(), i3(), i4(), l1(), l2(), l3());
  case O3PART_GCOS: return S.gcos(i1(), i2(), i3(), i4(), l1(), l2(), l3());
  case O3PART_SIBS: return S.sibs(i1(), i2(), i3(), i4(), l1(), l2(), l3());
  default: break;
  }
  /* unreachable... */
  assert(0);
  return 0;
}
