/* -*-c++-*- */
#ifndef O3PERCEPTRON_H
#define O3PERCEPTRON_H
/* O3Perceptron : Averaged perceptron training. */

#include "O3Parser.h"
#include "O3Features.h"
#include "O3Trainer.h"
#include "Bits.h"


class o3perceptron : public o3trainer {
public:
  o3perceptron();
  virtual ~o3perceptron();

protected:
  /* initialize the specialized trainer with options */
  virtual void usage_impl() const;
  virtual void init_impl(const o3trainer::strmap& opts);

  /* training interface */
  virtual void train_start();
  virtual void iter_start();
  virtual void iter_end(string& logline, string& repline);
  virtual void process(const ex* const restrict e);
  virtual void classify(const ex* const restrict e,
                        vector<int>& restrict ret_h,
                        vector<int>& restrict ret_l) const;

private:
  uint64_t _mistakes; /* number of mistakes made by the perceptron */
  double _margin;     /* margin for training */
};

#endif /* O3PERCEPTRON_H */
