/* -*-c++-*- */
#ifndef O3SPARSER_H
#define O3SPARSER_H

#include "O3Parser.h"

template<class PartScorer>
class o3sparser : public o3parser<PartScorer> {
public:
  virtual ~o3sparser();

protected:
  o3bruteforce(const int L,
               const bool multiroot,
               const bool pruned,
               const bool topdown);

  /* unravel the argmax backpointers; these are common to all
     subclasses of parsing algorithm */
  void unravel(vector<int>& ret_heads,
               vector<int>& ret_labels) const;
  void unravel_box(vector<int>& ret_heads,
                   vector<int>& ret_labels) const;
  void unravel_trap(vector<int>& ret_heads,
                    vector<int>& ret_labels) const;
  void unravel_wedge(vector<int>& ret_heads,
                     vector<int>& ret_labels) const;

private:
  /* disallow these entirely */
  o3bruteforce();
  o3bruteforce(const o3bruteforce& that);
  o3bruteforce& operator=(const o3bruteforce& that);
};

#include "O3SParser.tcc"

#endif /* O3SPARSER_H */
