/* -*-c++-*- */
#ifndef O3UNRAVEL_H
#define O3UNRAVEL_H
/* O3Unravel : Utilities for unraveling trees out of the third-order
   parser's backpointers. */

#include "O3Chart.h"

#include <vector>

using std::vector;

class o3unravel {
public:
  /* unravel the grandchild-parser's backpointers */
  static void gchdeps(const int N, const bool multiroot, const achart& C,
                      vector<int>& ret_heads, vector<int>& ret_labels);
  /* unravel the sibling-parser's backpointers */
  static void sibdeps(const int N, const bool multiroot, const achart& C,
                      vector<int>& ret_heads, vector<int>& ret_labels);
};

#endif /* O3UNRAVEL_H */
