/* -*-c++-*- */
#ifndef PADSENT_H
#define PADSENT_H
/* PadSent : A sentence containing arrays for various information
   about an input sentence like words and tags.  The sentence arrays
   are exposed publicly and they are padded with null tokens outside
   the normal range of the sentence. */

#include "Bits.h"
#include "Macros.h"

#include <vector>

using std::vector;

struct padsent {
  const int N;
  const word_t* const restrict words;
  const tag_t*  const restrict tags;
  const int*    const restrict quotelev;
  const int*    const restrict parenlev;

  padsent(const vector<int>& restrict w,
          const vector<int>& restrict t);
  ~padsent();
};

#endif /* PADSENT_H */
