#include "PartCollect.h"
#include "O3Part.h"

/* nested factory class */
class part_collect::fac : protected o3part {
  friend class part_collect;
};

part_collect::part_collect(const int N, const int L,
                           const bool sibparser,
                           o3part::vec& restrict ret)
  : _test(N, L, sibparser), _ret(ret) { _ret.clear(); }
part_collect::~part_collect() {}

double part_collect::
dep1(const idx_t h, const idx_t m, const lab_t l_hm) const {
  _test.dep1(h, m, l_hm);
  _ret.push_back(fac::mkdep1(h, m, l_hm));
  return 0;
}
double part_collect::
dep2(const idx_t h, const idx_t m, const lab_t l_hm) const {
  _test.dep2(h, m, l_hm);
  _ret.push_back(fac::mkdep2(h, m, l_hm));
  return 0;
}
double part_collect::
dep3(const idx_t h, const idx_t m, const lab_t l_hm) const {
  _test.dep3(h, m, l_hm);
  _ret.push_back(fac::mkdep3(h, m, l_hm));
  return 0;
}

double part_collect::
sib1(const idx_t h, const idx_t m, const idx_t c,
     const lab_t l_hm, const lab_t l_hc) const {
  _test.sib1(h, m, c, l_hm, l_hc);
  _ret.push_back(fac::mksib1(h, m, c, l_hm, l_hc));
  return 0;
}
double part_collect::
sib2(const idx_t h, const idx_t m, const idx_t c,
     const lab_t l_hm, const lab_t l_hc) const {
  _test.sib2(h, m, c, l_hm, l_hc);
  _ret.push_back(fac::mksib2(h, m, c, l_hm, l_hc));
  return 0;
}

double part_collect::
gci1(const idx_t h, const idx_t m, const idx_t c,
     const lab_t l_hm, const lab_t l_mc) const {
  _test.gci1(h, m, c, l_hm, l_mc);
  _ret.push_back(fac::mkgci1(h, m, c, l_hm, l_mc));
  return 0;
}
double part_collect::
gci2(const idx_t h, const idx_t m, const idx_t c,
     const lab_t l_hm, const lab_t l_mc) const {
  _test.gci2(h, m, c, l_hm, l_mc);
  _ret.push_back(fac::mkgci2(h, m, c, l_hm, l_mc));
  return 0;
}

double part_collect::
gco1(const idx_t h, const idx_t m, const idx_t c,
     const lab_t l_hm, const lab_t l_mc) const {
  _test.gco1(h, m, c, l_hm, l_mc);
  _ret.push_back(fac::mkgco1(h, m, c, l_hm, l_mc));
  return 0;
}
double part_collect::
gco2(const idx_t h, const idx_t m, const idx_t c,
     const lab_t l_hm, const lab_t l_mc) const {
  _test.gco2(h, m, c, l_hm, l_mc);
  _ret.push_back(fac::mkgco2(h, m, c, l_hm, l_mc));
  return 0;
}

double part_collect::
gcis(const idx_t h, const idx_t m, const idx_t c, const idx_t s,
     const lab_t l_hm, const lab_t l_mc, const lab_t l_ms) const {
  _test.gcis(h, m, c, s, l_hm, l_mc, l_ms);
  _ret.push_back(fac::mkgcis(h, m, c, s, l_hm, l_mc, l_ms));
  return 0;
}

double part_collect::
gcos(const idx_t h, const idx_t m, const idx_t c, const idx_t s,
     const lab_t l_hm, const lab_t l_mc, const lab_t l_ms) const {
  _test.gcos(h, m, c, s, l_hm, l_mc, l_ms);
  _ret.push_back(fac::mkgcos(h, m, c, s, l_hm, l_mc, l_ms));
  return 0;
}

double part_collect::
sibs(const idx_t h, const idx_t m, const idx_t c, const idx_t s,
     const lab_t l_hm, const lab_t l_hc, const lab_t l_hs) const {
  _test.sibs(h, m, c, s, l_hm, l_hc, l_hs);
  _ret.push_back(fac::mksibs(h, m, c, s, l_hm, l_hc, l_hs));
  return 0;
}
