/* -*-c++-*- */
#ifndef PART_SCORE_RANDOM_H
#define PART_SCORE_RANDOM_H
/* PartScoreRandom : A utility that assigns, and caches (for
   repeatability) random scores. */

#include "Macros.h"
#include "PartTest.h"
#include "O3Part.h"

class part_score_random {
public:
  part_score_random(const int N, const int L, const bool sibparser,
                    const double minsc, const double maxsc);
  ~part_score_random();

  double dep1(const idx_t h, const idx_t m, const lab_t l_hm) const;
  double dep2(const idx_t h, const idx_t m, const lab_t l_hm) const;
  double dep3(const idx_t h, const idx_t m, const lab_t l_hm) const;
  double sib1(const idx_t h, const idx_t m, const idx_t c,
              const lab_t l_hm, const lab_t l_hc) const;
  double sib2(const idx_t h, const idx_t m, const idx_t c,
              const lab_t l_hm, const lab_t l_hc) const;
  double gci1(const idx_t h, const idx_t m, const idx_t c,
              const lab_t l_hm, const lab_t l_mc) const;
  double gci2(const idx_t h, const idx_t m, const idx_t c,
              const lab_t l_hm, const lab_t l_mc) const;
  double gco1(const idx_t h, const idx_t m, const idx_t c,
              const lab_t l_hm, const lab_t l_mc) const;
  double gco2(const idx_t h, const idx_t m, const idx_t c,
              const lab_t l_hm, const lab_t l_mc) const;
  double gcis(const idx_t h, const idx_t m, const idx_t c, const idx_t s,
              const lab_t l_hm, const lab_t l_mc, const lab_t l_ms) const;
  double gcos(const idx_t h, const idx_t m, const idx_t c, const idx_t s,
              const lab_t l_hm, const lab_t l_mc, const lab_t l_ms) const;
  double sibs(const idx_t h, const idx_t m, const idx_t c, const idx_t s,
              const lab_t l_hm, const lab_t l_hc, const lab_t l_hs) const;

private:
  struct fac; /* part-creation factory */

  const part_test _test;  /* part-tester for checks */
  const double _min;      /* minimum allowable score */
  const double _max;      /* maximum allowable score */
  const double _range;    /* range between min->max */
  o3part::dmap* const _S; /* cache of random scores */

  /* return a random score, possibly generating it first */
  double randscore(const o3part& restrict p) const;
};

#endif /* PART_SCORE_RANDOM_H */
