/* -*-c++-*- */
#ifndef PART_SCORE_TREE_H
#define PART_SCORE_TREE_H
/* PartScoreTree : A utility that scores things according to how well
   they match a reference tree */

#include "Macros.h"
#include "PartTest.h"

#include <vector>

using std::vector;

class part_score_tree {
public:
  part_score_tree(const int N, const int L, const bool sibparser,
                  const vector<int>& restrict h,
                  const vector<int>& restrict l);
  ~part_score_tree();

  double dep1(const idx_t h, const idx_t m, const lab_t l_hm) const;
  double dep2(const idx_t h, const idx_t m, const lab_t l_hm) const;
  double dep3(const idx_t h, const idx_t m, const lab_t l_hm) const;
  double sib1(const idx_t h, const idx_t m, const idx_t c,
              const lab_t l_hm, const lab_t l_hc) const;
  double sib2(const idx_t h, const idx_t m, const idx_t c,
              const lab_t l_hm, const lab_t l_hc) const;
  double gci1(const idx_t h, const idx_t m, const idx_t c,
              const lab_t l_hm, const lab_t l_mc) const;
  double gci2(const idx_t h, const idx_t m, const idx_t c,
              const lab_t l_hm, const lab_t l_mc) const;
  double gco1(const idx_t h, const idx_t m, const idx_t c,
              const lab_t l_hm, const lab_t l_mc) const;
  double gco2(const idx_t h, const idx_t m, const idx_t c,
              const lab_t l_hm, const lab_t l_mc) const;
  double gcis(const idx_t h, const idx_t m, const idx_t c, const idx_t s,
              const lab_t l_hm, const lab_t l_mc, const lab_t l_ms) const;
  double gcos(const idx_t h, const idx_t m, const idx_t c, const idx_t s,
              const lab_t l_hm, const lab_t l_mc, const lab_t l_ms) const;
  double sibs(const idx_t h, const idx_t m, const idx_t c, const idx_t s,
              const lab_t l_hm, const lab_t l_hc, const lab_t l_hs) const;

private:
  const part_test _test; /* part-tester for checks */
  vector<int> _h;        /* reference head-list */
  vector<int> _l;        /* reference label-list */
};

#endif /* PART_SCORE_TREE_H */
