/* -*-c++-*- */
#ifndef PART_SCORER_H
#define PART_SCORER_H
/* PartScorer : A base class for part-scorers.  It is not necessary to
   begin from this base class but it may be convenient.  All methods
   in this base class throw errors. */

#include "Bits.h"

class part_scorer {
public:
  double dep1(const idx_t h, const idx_t m, const lab_t l_hm) const;
  double dep2(const idx_t h, const idx_t m, const lab_t l_hm) const;
  double dep3(const idx_t h, const idx_t m, const lab_t l_hm) const;
  double sib1(const idx_t h, const idx_t m, const idx_t c,
              const lab_t l_hm, const lab_t l_hc) const;
  double sib2(const idx_t h, const idx_t m, const idx_t c,
              const lab_t l_hm, const lab_t l_hc) const;
  double gci1(const idx_t h, const idx_t m, const idx_t c,
              const lab_t l_hm, const lab_t l_mc) const;
  double gci2(const idx_t h, const idx_t m, const idx_t c,
              const lab_t l_hm, const lab_t l_mc) const;
  double gco1(const idx_t h, const idx_t m, const idx_t c,
              const lab_t l_hm, const lab_t l_mc) const;
  double gco2(const idx_t h, const idx_t m, const idx_t c,
              const lab_t l_hm, const lab_t l_mc) const;
  double gcis(const idx_t h, const idx_t m, const idx_t c, const idx_t s,
              const lab_t l_hm, const lab_t l_mc, const lab_t l_ms) const;
  double gcos(const idx_t h, const idx_t m, const idx_t c, const idx_t s,
              const lab_t l_hm, const lab_t l_mc, const lab_t l_ms) const;
  double sibs(const idx_t h, const idx_t m, const idx_t c, const idx_t s,
              const lab_t l_hm, const lab_t l_hc, const lab_t l_hs) const;

protected:
  part_scorer();
  ~part_scorer();
};

#endif /* PART_SCORER_H */
