/* -*-c++-*- */
#ifndef SAFE_NEW_H
#define SAFE_NEW_H
/* SafeNew : new with exception handling */

#include "Bits.h"

#include <assert.h>

#include <iostream>
#include <exception>

/* allocate an array of objects */
template<class T>
static inline T* safe_new(const uint64_t n) {
  using std::cerr;
  using std::endl;
  using std::exception;
  try { return new T[n]; }
  catch(exception& e) {
    cerr << "Exception during memory allocation: "
         << e.what() << endl;
    assert(0);
  }
  return NULL;
}

#endif /* SAFE_NEW_H */
