/* -*-c++-*- */
#ifndef TESTINF_H
#define TESTINF_H
/* TestInf : Procedures for testing the parser's inference routines */

#include "Macros.h"

class o3parser;
class testinf {
public:
  /* simple argmax tests against constructed trees */
  static void simple(const int N, o3parser* const restrict P);
  /* test the full parser against a brute-force implementation */
  static void bruteforce(const int N, const int L);
  /* test the pruned parser against a brute-force implementation.
     dependencies are randomly pruned; an edge is kept with probability
     p_keep. */
  static void pruned(const int N, const int L, const double p_keep);
  /* test the top-down and bottom-up implementations against each
     other, with optional pruning */
  static void tdbu(const int N, const int L, const double p_keep = 1.0);
};

#endif /* TESTINF_H */
