#include "Timer.h"

#include <stdio.h>

/* global variables controlling report intervals */
int TICKER_REPINT_LOG = 5;
int TICKER_REPINT = 0x1f;

void ticker_adjust_repint(int log_factor) {
  TICKER_REPINT_LOG += log_factor;
  if(log_factor < 0) {
    TICKER_REPINT >>= -log_factor;
  } else if(log_factor > 0) {
    for(int i = 0; i < log_factor; ++i) {
      TICKER_REPINT = (TICKER_REPINT << 1) | 1;
    }
  }
}

const char* timestr(double seconds) {
  static char buf[9];
  sprintf(buf, "        "); /* clear buffer */
  if(seconds < 60) { /* < 1 minute */
    sprintf(buf, "%.4fs", seconds);
  } else if(seconds < 3600) { /* < 1 hour */
    int minutes = ((int)seconds)/60;
    seconds -= minutes*60;
    sprintf(buf, "%02d:%05.2f", minutes, seconds);
  } else if(seconds < 86400) { /* < 1 day */
    int hours  = ((int)seconds)/3600;
    seconds -= hours*3600;
    int minutes = ((int)seconds)/60;
    seconds -= minutes*60;
    sprintf(buf, "%02d:%02d:%02d", hours, minutes, (int)seconds);
  } else if(seconds < 864000) { /* < 10 days */
    int days = ((int)seconds)/86400;
    seconds -= days*86400;
    seconds /= 3600;
    sprintf(buf, "%dd %.1fh", days, seconds);
  } else if(seconds < 31536000) { /* < 1 year */
    seconds /= 86400;
    sprintf(buf, "%.2fd", seconds);
  } else {
    sprintf(buf, "> 1 year");
  }
  return buf;
}
