#include "TreeFunctors.h"

#include "O3Part.h"
#include "Hashtable.h"

/* argmax tree-functor */
treef_argmax::treef_argmax()
  : _score(-HUGE_VAL), _p(), _l() {}
treef_argmax::~treef_argmax() {}


/* partition-function tree-functor */
treef_partition::treef_partition()
  : _logZ(-HUGE_VAL) { assert(exp(_logZ) == 0); }
treef_partition::~treef_partition() {}


/* marginals tree-functor */
treef_marginals::treef_marginals(o3part::dmap& restrict M)
  : _logZ(-HUGE_VAL), _M(M) { _M.clear(); assert(exp(_logZ) == 0); }
treef_marginals::~treef_marginals() {}

void treef_marginals::operator()(const vector<int>& restrict p,
                                 const vector<int>& restrict l,
                                 const o3part::vec& restrict y,
                                 const double score) {
  _logZ = log_add(_logZ, score);
  const int YR = (int)y.size();
  for(int i = 0; i < YR; ++i) {
    double& restrict p_r = _M.mget(y[i], -HUGE_VAL);
    p_r = log_add(p_r, score);
  }
}

void treef_marginals::mkprobs() { /* convert log-probs to probs */
  o3part::dmap::iterator it = _M.begin();
  const o3part::dmap::iterator iend = _M.end();
  for(; it != iend; ++it) { it->val = exp(it->val - _logZ); }
}
