#!/bin/bash

if [ $# -ne 4 ] ; then
    echo "usage: $0 <dir1> <dir2> <iter1> <iter2>"
    exit 1
fi

dir1=$1
dir2=$2
iter1=$3
iter2=$4

padnum1=$(printf '%03d' $iter1)
padnum2=$(printf '%03d' $iter2)
lang=none
if grep -q '/eng.' $dir1/options ; then lang=eng ; fi
if grep -q '/cze.' $dir1/options ; then lang=cze ; fi
if grep -q '/chi.' $dir1/options ; then lang=chi ; fi

paste \
    /data/nlp4/maestro/dp/data/$lang/$lang.val.original \
    $dir1/val-labels.$padnum1 \
    $dir2/val-labels.$padnum2 \
    | awk '
NF==0 { print }
NF>0 {
  printf "%-5d %-4s %-18s %-3d %s%-3d %s%-3d %s\n",
         $1, $5, $2, $7,
         ($11!=$7 ? "*" : " "), $11,
         ($15!=$7 ? "*" : " "), $15,
         ($11==$15 ? "==" : "!=")
}'
