#!/bin/bash

awk '
BEGIN {
  eq_num = 0;
  ne_num = 0;
  eq_err = 0;
  ne_err1 = 0;
  ne_err2 = 0;
}
NF>0 && $NF=="=="                 { ++eq_num; }
NF>0 && $NF=="==" && $5~/\*[0-9]/ { ++eq_err; }
NF>0 && $NF=="!="                 { ++ne_num; }
NF>0 && $NF=="!=" && $5~/\*[0-9]/ { ++ne_err1; }
NF>0 && $NF=="!=" && $6~/\*[0-9]/ { ++ne_err2; }
END {
  eq_cor   = eq_num - eq_err;
  ne_cor1  = ne_num - ne_err1;
  ne_cor2  = ne_num - ne_err2;
  all_cor1 = eq_cor + ne_cor1;
  all_cor2 = eq_cor + ne_cor2;
  all_num  = eq_num + ne_num;
  printf "==    : %-6.2f = %d / %d\n", 100.0*eq_cor/eq_num,  eq_cor,  eq_num;
  printf "!=[1] : %-6.2f = %d / %d\n", 100.0*ne_cor1/ne_num, ne_cor1, ne_num;
  printf "!=[2] : %-6.2f = %d / %d\n", 100.0*ne_cor2/ne_num, ne_cor2, ne_num;
  printf "**[1] : %-6.2f = %d / %d\n", 100.0*all_cor1/all_num, all_cor1, all_num;
  printf "**[2] : %-6.2f = %d / %d\n", 100.0*all_cor2/all_num, all_cor2, all_num;
}
'