#!/usr/bin/perl -w

my $stem = shift;

my $origdir = `pwd`;
chomp($origdir);

foreach my $dir (@ARGV) {
    print $dir;
    chdir($dir);
    my @files = sort(<$stem*>);
    if(scalar(@files) == 0) {
        print " <???>\n";
    } else {
        my $lastfile = $files[$#files];
        my $lastdays = (-M $lastfile);
        my $old = ($lastdays > 0.25);
        my $lasttime = &strtime($lastdays);
        my $average = 0;
        if(scalar(@files) > 1) {
            my $firstdays = (-M $files[0]);
            my $difftime = $firstdays - $lastdays;
            # average timediff between sequential files
            $average = ($difftime / $#files);
        }
        print " $lastfile ".
            ($old ? "<$lasttime>" : "[$lasttime]").
            " (".&strtime($average).")\n";

    }
    chdir($origdir);
}


sub strtime {
    my $days = shift;
    return sprintf("%.3fd", $days) if($days >= 1);
    my $h = 24*$days;
    my $m = 60*($h - int($h));
    $h = int($h);
    my $s = 60*($m - int($m));
    $m = int($m);
    return sprintf("%02d:%02d:%02d", $h, $m, int($s));
#    return sprintf("%02d:%02.2f", $m, $s);
}
